#include "allegro.h"

int main(int argc, char* argv[])
{
	BITMAP *buffer;
	int x1 = -100, y1 = -100;
	int x = 0, y = 0;
	int px, py;

	allegro_init();
	if (install_mouse() < 2) 
	{
		allegro_message("Must have a mouse with at least two buttons.");
		exit(0);
	}
	
	set_color_depth(16);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640,480, 0,0);

	if (!(buffer = create_bitmap(SCREEN_W, SCREEN_H)))
	{
		allegro_message("Unable to set graphics mode.");
		exit(0);
	}


   	do {
		if (mouse_b && 1)
		{
			while (mouse_b && 1) poll_mouse();
			px = rand() % SCREEN_W;
			py = rand() % SCREEN_H;
			position_mouse(px,py);
			x1 = y1 = -100;		
		}

		poll_mouse();
		get_mouse_mickeys(&x, &y);
		if (x1 == -100 && y1 == -100)
		{
			x1 = x;
			y1 = y;
		}

		show_mouse(NULL);
		clear(buffer);
		textprintf(buffer, font, 0,0, makecol(255,255,255), "Positioned Mouse: %i, %i", px, py);
		textprintf(buffer, font, 0,16, makecol(255,255,255), "First Call: %i, %i", x1, y1);
		textprintf(buffer, font, 0,32, makecol(255,255,255), "Last Call: %i, %i", x, y);		
		show_mouse(buffer);

		acquire_screen();
		blit(buffer, screen, 0,0, 0,0, SCREEN_W, SCREEN_H);
		release_screen();
	} while (!(mouse_b & 2));
	
	show_mouse(NULL);	
	destroy_bitmap(buffer);

	exit ( 1);

	return 0;
}
END_OF_MAIN()